<?php

/*
Performances File Browser
*/

include_once("config.php");

// constants and configuration

// this vars can get transferred here

if(!isset($_REQUEST["dir"]))	$_REQUEST["dir"]="";
if(!isset($_REQUEST["delete"]))	$_REQUEST["delete"]="";
if(!isset($_REQUEST["rename"]))	$_REQUEST["rename"]="";
if(!isset($_REQUEST["recopy"]))	$_REQUEST["recopy"]="";
if(!isset($_REQUEST["file"]))	$_REQUEST["file"]="";
if(!isset($_REQUEST["newfile"]))	$_REQUEST["newfile"]="";

// this needed in tinybrowser.php to enter the correct specialized folders
$addvars="";

$dir = $_REQUEST["dir"];
$delete = $_REQUEST["delete"];
$rename = $_REQUEST["rename"];
$recopy = $_REQUEST["recopy"];
$file = $_REQUEST["file"];
$newfile = $_REQUEST["newfile"];

$basedir = '/'.MEDIADIR;

// check if no file sent here -  just the http root
if($dir."/" == SITEROOT) $dir="/"; 
// files or directories should be urldecoded
$dir = urldecode($dir);

// cut http root folder
$dir = str_replace(SITEROOT,"",$dir);
$dir = str_replace(ROOTFOLDER,"",$dir);

if(!$dir || $dir=="/")	$dir = $basedir;

// allow certain subfolders and media to be created and deleted
$deletinsubdirs = array("/".MEDIADIR);

$valid_file_types = array("json", "perf");

// end configuration

/*
 original script VS Babu vsbabu@hotmail.com http://vsbabu.org
*/

// Get the extension of a file
function get_extension($filename){
  $x=explode(".",strrev(strtolower($filename)));
  return strrev($x[0]);
}

// Returns the path minus root folder path. Also takes out the leading /
function cut_root_folder($sub_folder){
	if (strlen($sub_folder) > strlen(ROOTFOLDER)){
		$fld=str_replace(ROOTFOLDER, "", $sub_folder);
		$fld = preg_replace("/^\/+/","",$fld);
		return $fld;
	} else {
		return "";	
	}
}

// Print a file's size
function print_filesize($file){
	$s=filesize($file);
	if($s>1024*1024){
		$s=round($s/(1024*1024));
		return $s." MB";
	}
	if($s>1024){
		$s=round($s/1024);
		return $s." KB";
	}
	return $s." B";
}

//Prints directory
function print_copy_dir($dirpath, $dirname) {
	$dirpath=preg_replace("/\/+/","/",$dirpath);
	$dir=str_replace(ROOTFOLDER,SITEROOT,$dirpath);
	$dirpath=str_replace(ROOTFOLDER,"",$dirpath);
	// replace underscores with spaces
	$dirname=str_replace("_"," ",$dirname);
}


// print the dirs at the top to navigate to parent folders
// dir is absolute path, prevdir is relative
function print_header_links($dir, $prevdir){
global $basedir;

	// dir path is verified against site root as a mild security
	$dir = preg_replace("/\/$/","",$dir);
	$dir = cut_root_folder($dir);
	$dir_arr = explode("/", $dir);

	//print_r ($dir_arr);
	$prev_folder = "";

	if($dir!=""){

		$back = str_replace($prevdir,"",$dir);
		for($i=0;$i<sizeof($dir_arr); $i++){
			if($i>0) echo "<br>\n";
			// bring open folders to right
			for($x=1;$x<=$i;$x++) echo "&nbsp;&nbsp;";
			$thisfolder = $dir_arr[$i];
			// root name or .. or something else

			if($dir_arr[$i]=="") 	$thisfolder = $basedir;
			$prev_folder = $prev_folder."/".$dir_arr[$i];
			$prev_folder = str_replace("//","/",$prev_folder);
			if($i==sizeof($dir_arr)-1)	{
				echo "<span class=\"entryicon folder\"><img hspace=\"2\" src=\"".SITEROOT."/images/openfold.png\" border=\"0\"></span>";
			}
			$lastfolder = $thisfolder;
		}
		echo "<b>".$lastfolder."</b><br><hr>";
	}
} // print_header_links end

// main process
// dir is relative
function main_process($dir){
global $delete, $rename, $recopy, $file, $newfile;

	// get the previous dir
	$dirarr = explode("/", $dir);
	// remove the last element
	array_pop($dirarr);
	$prevdir = $dir; // default is same as dir
	$prevdir = implode("/", $dirarr);
	
	if($delete || $rename || $recopy) {
		// absolute path
		$file = ROOTFOLDER.$file;
		if(!file_exists($file)) $file = rawurldecode($file);
		if(isset($file) && file_exists($file))	{
			if($delete=="Yes") {
				if(is_dir($file))	rmdir($file);
				else 			unlink($file);
			} elseif($delete=="May") {
				//relative path
				$fil=str_replace(ROOTFOLDER,"",$file);
				$alert = "OK to delete file \"".$fil."\"?";
				echo "<script language = \"javascript\">";
				echo "if(!confirm('".$alert."')) history.go(-1);";
				echo "else	window.location='".$_SERVER['PHP_SELF']."?dir=".$dir."&delete=Yes&file=".rawurlencode($fil)."'";
				echo "</script>"; 
			}
			// rename ...
			if($rename=="Yes") {
				if(!@rename($file,ROOTFOLDER.$newfile)) echo "Could not rename this file...  a file by that name probably exists...";
			} elseif($rename=="May") {
				//relative path
				$fil=str_replace(ROOTFOLDER,"",$file);
				$alert = "Rename file \"".$fil."\" to ";
				echo "<script language = \"javascript\">";
				echo "var newfile = prompt('".$alert."','".$fil."');";
				echo "if(newfile==null || newfile=='".$fil."'){ history.go(-1);}";
				echo "else{	window.location='".$_SERVER['PHP_SELF']."?dir=".$dir."&rename=Yes&file=".rawurlencode($fil)."&newfile='+newfile;}";
				echo "</script>"; 
			}
			// copy ...
			if($recopy=="Yes") {
				if(!@copy($file,ROOTFOLDER.$newfile)) echo "Could not copy this file... a file by that name probably exists...";
			} elseif($recopy=="May") {
				//relative path
				$fil=str_replace(ROOTFOLDER,"",$file);
				$alert = "Copy file \"".$fil."\" to ";
				echo "<script language = \"javascript\">";
				echo "var newfile = prompt('".$alert."','".$fil."');";
				echo "if(newfile==null || newfile=='".$fil."'){ history.go(-1);}";
				echo "else{	window.location='".$_SERVER['PHP_SELF']."?dir=".$dir."&recopy=Yes&file=".rawurlencode($fil)."&newfile='+newfile;}";
				echo "</script>"; 
			}
		}
	}
	display_directory($dir, $prevdir);
}

// display the contents of a directory
// add functionality to browse deeper into folders
// $dir is relative location, $prevdir is relative
function display_directory($dir, $prevdir){
global $basedir, $valid_file_types, $deletinsubdirs;
	
	$dir = preg_replace("/\/+/", "/", $dir."/"); // squeeze extra slashes

	//$basedir = str_replace($basedir, "", $dir);
	$basedir = $dir;
	$bdirs = array_values(array_filter(explode("/", $basedir)));
	$basedir = $bdirs[0];

	// make it absolute
	$dir = ROOTFOLDER.$dir;

	print_header_links($dir, $prevdir);

	//Display every file in the folder with extensions in valid_file_types
	// here we need absolute path
	
	if(!($d=dir($dir))){
		echo "\t Cannot open directory - [".$dir."]";
		return;
	}
	
	// read dir contents
	$filemtimes = array(); 	
	while($entry=$d->read()){
		if(is_dir($dir."/".$entry) && $entry!='.' && $entry!='..') $dirlist[] = $entry;
		if(is_file($dir."/".$entry)){
			$ext = get_extension($entry);
			if(in_array($ext,$valid_file_types)){
				// order files by file modified - if no info this overwrites the elements in array
				$ftime = filemtime($dir."/".$entry); // modified
				//$ftime = filectime($dir."/".$entry); //created
				if(in_array($ftime, $filemtimes))	$ftime = $ftime + 1;
				$filemtimes[]=$ftime;
				$filelist[$ftime] = $entry;
			}	
		}
	}

	// to relative	
	$dir=str_replace(ROOTFOLDER, "", $dir);
	if(isset($filelist)) {
		// sort by key reversed - the filectime or filemtime
		krsort($filelist);
		foreach($filelist AS $ftime=>$entry) {
			$ext = get_extension($entry);
			$entryid = str_replace(".".$ext, "", $entry);
			echo "<div class=\"entry\" id=\"fil_".$entryid."\">";
			
			print_copy_link($dir.$entry, $entry, $dir, $ftime, $ext);
			
			echo "<span class=\"entryoperations\">";
			$entrypath = $dir.$entry;
			$allowdel=0;
			foreach($deletinsubdirs AS $delsub){
				// just count characters left after replacing a substring
				$substr = str_replace($delsub, "", $entrypath);
				if(strlen($substr)< strlen($entrypath)){
					$allowdel=1;
					break;
				}	
			}
			if($allowdel){
				echo "<a href=\"".$_SERVER['PHP_SELF']."?dir=".$dir."&delete=May&file=".rawurlencode($dir.$entry)."\" title=\"delete\" class=\"delete\">x</a>";
				echo "<a href=\"".$_SERVER['PHP_SELF']."?dir=".$dir."&amp;rename=May&file=".rawurlencode($dir.$entry)."\" title=\"rename\" class=\"rename\">&reg;</a>";	
				echo "<a href=\"".$_SERVER['PHP_SELF']."?dir=".$dir."&amp;recopy=May&file=".rawurlencode($dir.$entry)."\" title=\"copy\" class=\"copy\">&copy;</a>";	
			}
			echo "</span>";
			echo "</div>";
		}
	}
} // display_directory end

// links for copying the path to some form field
// trigger ajax events, thumb creation, path adptation, etc
// imgpath is relative
function print_copy_link($imgpath, $filename, $dir, $ftime, $ext) {
	// relative path needs absolute to getimagesize
	$imgpath = ROOTFOLDER.$imgpath;
	$filesize = print_filesize($imgpath);
	$img="";
	$width = 0;
	$height = 0;
	// for images	
	if($imgsize=GetImageSize($imgpath)){
		$width=$imgsize[0];
		$height=$imgsize[1];
	}	
	$imgpath=preg_replace("/\/+/","/",$imgpath);
	//echo $imgpath;
	$img=str_replace(ROOTFOLDER,SITEROOT,$imgpath);
	//echo $img;

	// resize name
	if(strlen($filename)>25) $name = substr($filename, 0, 25)."...";
	else $name = $filename;

	$date="";
	if($ftime){
		$today = date("Y-m-d");
		if($today == date("Y-m-d", $ftime)) $date = "today at ".date("h:i:s", $ftime)."";
		else $date = date("Y-m-d h:i:s", $ftime);		
	}	
	
	echo "<span class=\"entryicon\"><img hspace=\"6\" src=\"".SITEROOT."/images/".strtoupper($ext).".png\" border=\"0\"></span>";
	//echo "</a>";
	echo "<span class=\"entrydetails\"><strong>".$name."</strong>";
	echo "<br>Filesize: ".$filesize;
	echo "<br>Modified: ".$date;
	if(!empty($imgsize))	echo "<br>Dimensions: ".$height."x".$width."";
	echo "</span>";
}

?>

<html><head>
<style type='text/css'>

body {
	background-color: #F0F0EE;
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 14px;
}
.entry {
	display:inline-block;
	float:left;
	height:inherit;
	min-width:300px;
	padding:5px;
	padding-bottom:10px;
	margin:5px;
	border-bottom:1px solid #ccc;
	white-space:nowrap;
}
.entryicon {
	display:inline-block;
	margin-right:0px;
}
.entryicon.folder {
	vertical-align:middle;
	margin-right:3px;
}
.entrydetails {
	display:inline-block;
	vertical-align:top;
}
.entryoperations {
	display:inline-block;
	float:right;
	height:inherit;
}
a.delete, a.rename, a.copy {
	display:block;
	text-align:center;
	font-size: 22px;
	padding:0;
	width:50px;
	text-decoration:none;
	color:#000;
}
a.delete:visited, a.rename:visited, a.copy:visited {
	color:#000;
}

.alertfont {
	color:red;
}
</style>

</head><body>
<?php 
if(!isset($dir))	$dir="";
// open filebrowser in selected directory
main_process($dir);
?>
</body></html>
